//#property  copyright "Copyright  2005, Yura Prokofiev"
//#property  link      "Yura.prokofiev@gmail.com"
// Modofied by ACS to create sound alert and Text Signals and option to calculate the proper way.
// 30-Nov-07. Smoothing made extern variable on 12-Apr-08.
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  Blue
#property  indicator_color3  Red
#property  indicator_width1 2
#property  indicator_width2 2
#property  indicator_width3 2

extern int period=10;
extern double Smooth = 0.67;
extern int option=1;  // option 1 will make it NOT a repainter. Other options leave it as a repainter!
extern bool SoundAlert  = false;
extern string SoundFile="alert";

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
int LastBar=-1;
string TextDir="SolarWind-ACS3";
//=====================================================================
void init() {
   IndicatorDigits(Digits+1);
   IndicatorShortName("SOLAR WIND-ACS3 ("+Symbol()+","+period+")");
   SetIndexBuffer(0,ExtBuffer0); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,ExtBuffer1); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"SolarWind-UP");
   SetIndexBuffer(2,ExtBuffer2); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"SolarWind-DN");
return; }
//=====================================================================
int deinit() { ObjectDelete(TextDir); return(0); }
//=====================================================================
int start() {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,old;
   double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
   double price;
   double MinL=0;
   double MaxH=0;  

   if(counted_bars>0) counted_bars--; limit=Bars-counted_bars;

if (option!=1) {
   for(int i=0; i<limit; i++)
    {  MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
       MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
      price = (High[i]+Low[i])/2;
      Value = (1-Smooth)*2*((price-MinL)/(MaxH-MinL)-0.5) + Smooth*Value1;     
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      ExtBuffer0[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
      Value1=Value;
      Fish1=ExtBuffer0[i];
    } }

if (option==1) {
   for(i=limit-2; i>=0; i--)
    {  MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
       MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
      price = (High[i]+Low[i])/2;
      Value = (1-Smooth)*2*((price-MinL)/(MaxH-MinL)-0.5) + Smooth*Value1;     
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      ExtBuffer0[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
      Value1=Value;
      Fish1=ExtBuffer0[i];
    } }

   bool up=true;
   for(i=limit-2; i>=0; i--) {
      current=ExtBuffer0[i]; prev=ExtBuffer0[i+1];
      if (((current<0)&&(prev>0))||(current<0)) up= false;  if (((current>0)&&(prev<0))||(current>0)) up= true;
      if(!up) { ExtBuffer2[i]=current;  ExtBuffer1[i]=0.0; }
         else { ExtBuffer1[i]=current;  ExtBuffer2[i]=0.0; }
     }
   if (!SoundAlert || LastBar >= Bars) return(0);
   if (ExtBuffer1[0] > 0 && ExtBuffer1[1] <= 0) { Alert("Solar wind on ",Symbol()," crossed above 0."); PlaySound(SoundFile); LastBar=Bars; }
   if (ExtBuffer2[0] < 0 && ExtBuffer2[1] >= 0) { Alert("Solar wind on ",Symbol()," crossed below 0."); PlaySound(SoundFile); LastBar=Bars; }
return(0); }


